
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from random import *

from rng import *
from strength import *
from dexterity import *

class DeityBase(RNG):
    "Random Number God Subclass for deity powers granted to player"
    def __init__(self):
        RNG.__init__(self, self) 
	self.enhancedpowerbydeity = 0.0
	self.deityfunctions = dict()
	self.neutralminimumlimit = -5.0
	self.neutralmaximumlimit = +5.0

	self.strength = Strength(10)
	self.dexterity = Dexterity(10)

    def doesnothing(self):
	1

    def doesmore(self):
	return self.rolld4()

    def deitywatches(self, deitypoints, powerslist):
	for el in powerslist:
		if el in deityfunctions.keys():
			deityfunctions[el]()
			if self.doesmore() == 1:
				continue
			else:
				return 0

    def rolld200(self):
        return (randint(1,200) + self.enhancedpowerbydeity)

    def rolld100(self):
        return (randint(1,100) + self.enhancedpowerbydeity)

    def rolld50(self):
        return (randint(1,50) + self.enhancedpowerbydeity)

    def rolld40(self):
        return (randint(1,40) + self.enhancedpowerbydeity)

    def rolld20(self):
        return (randint(1,10) + self.enhancedpowerbydeity)

    def rolld10(self):
        return (randint(1,10) + self.enhancedpowerbydeity)

    def rolld6(self):
        return (randint(1,6) + self.enhancedpowerbydeity)

    def rolld5(self):
        return (randint(1,5) + self.enhancedpowerbydeity)

    def rolld4(self):
        return (randint(1,4) + self.enhancedpowerbydeity)

    def rolld2(self):
        return (randint(1,2) + self.enhancedpowerbydeity)

    def rollbetween(self, min, max):
	return (randint(min,max) + self.enhancedpowerbydeity)

    
