
# Copyright (C) Johan Ceuppens 2011
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *

from maproom1 import *
from maproomsewer1 import *
from maproom2_1 import *
from maproom2_2 import *
from maproom2_3 import *
from maproom2_4 import *

from taskbar import *
from time import *
from inventory import *
from spellbook import *
from priestspells import *
from priestspellsenhancepower import *
from meter import *
from manameter import *
from selectorrace import *
from selectorclass import *
from playerlink import *

from inventorybow1 import *
from inventoryknife1 import *
from inventoryspidereye import *

from spellbookscrollmagicmissile1 import * 
from spellbookscrollmagicmissile2 import * 
from spellbookscrollmagicmissile3 import * 
from spellbookscrollseeinvisibility import *

class Game:
    "Main function"
    def __init__(self):
        pygame.init()
        pygame.font.init()
        self.screen = pygame.display.set_mode((640, 480))
        self.font = pygame.font.SysFont("Times", 14)
        self.font2 = pygame.font.SysFont("Coutier", 36)
        self.font3 = pygame.font.SysFont("Vera", 52)
        blankimage = pygame.image.load('./pics/blank.bmp').convert()
        ## There are several title screens in the ./pics/ directory
        titleimage = pygame.image.load('./pics/titlescreen.bmp').convert()
        gameover = 0
        while gameover == 0:
            pygame.display.update()
            self.screen.blit(titleimage, (0,0))
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    gameover = 1
                if event.type == pygame.MOUSEBUTTONDOWN:
                    gameover = 1

            
        gameover = 0

        askplayers = 0 # NOTE: 2 Player flag
        
        self.x = 0
        self.y = 0
      	self.key1 = 0 

	self.bossflag1 = 0
	self.spidereye = 0

        heartmeter = Meter()
        manameter = ManaMeter()

        ##### self.player = PlayerLink(heartmeter,280,300)
        self.raceselector = RaceSelector(self.screen, self.font)
       	self.classselector = ClassSelector(self.screen,self.font) 
	### heartmeter = Meter()
	### player = PlayerFighter(heartmeter)##default fighter class
        self.raceselector.select()
	if self.raceselector.askrace() == "Human":
		self.classselector.select()
        	if self.classselector.askclass() == "Fighter":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.HUMAN,PlayerBaseClass0.FIGHTER)
        	elif self.classselector.askclass() == "Magic User":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.HUMAN,PlayerBaseClass0.MAGICUSER)
        	elif self.classselector.askclass() == "Rogue":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.HUMAN,PlayerBaseClass0.THIEF)
        elif self.raceselector.askrace() == "Gnoll":
		self.classselector.select()
            	if self.classselector.askclass() == "Fighter":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.GNOLL,PlayerBaseClass0.FIGHTER)
        	elif self.classselector.askclass() == "Magic User":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.GNOLL,PlayerBaseClass0.MAGICUSER)
        	elif self.classselector.askclass() == "Rogue":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.GNOLL,PlayerBaseClass0.THIEF)
        elif self.raceselector.askrace() == "Katta":
		self.classselector.select()
            	if self.classselector.askclass() == "Fighter":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.KATTA,PlayerBaseClass0.FIGHTER)
        	elif self.classselector.askclass() == "Magic User":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.KATTA,PlayerBaseClass0.MAGICUSER)
        	elif self.classselector.askclass() == "Rogue":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.KATTA,PlayerBaseClass0.THIEF)
        elif self.raceselector.askrace() == "Elf":
		self.classselector.select()
            	if self.classselector.askclass() == "Fighter":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.ELF,PlayerBaseClass0.FIGHTER)
        	elif self.classselector.askclass() == "Magic User":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.ELF,PlayerBaseClass0.MAGICUSER)
        	elif self.classselector.askclass() == "Rogue":
			self.player = PlayerLink(heartmeter,280,300,PlayerBaseRace0.ELF,PlayerBaseClass0.THIEF)
        
        pygame.key.set_repeat(10,100)
        self.keydown = 0
        
        self.taskbar = Taskbar(self.screen,self.font,self.player)

	self.currentdomain = None

	self.prevroomnumber = 1
	self.roomnumber = 1
        self.room = Maproom1(0,0)
        ### self.room = Maproom2_1(-3400,-800) ### beneath mountains
        ### self.room = Maproom2_2(100,0) ###sewer beneath mountains
        ### self.room = Maproom2_3(0,0,self) ###hold beneath mountains, spider boss
        ### self.room = Maproom2_4(0,0,self) ###beneath mountains, endless caves 
	### test 
	### self.room.inventorykey1 = 1 
      	###self.key1 = 1 

        self.talker = None
        gameflag = 0
        while gameover == 0:
            self.player.h = 72 # NOTE: for ducking, FIXME 48
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
            	    self.keydown = 1
                    # self.player 1 key controls
                    
                    if event.key == K_x:
                        self.talker = self.player.talk(self)
                    elif event.key == K_z:
                        self.player.fight(self.room,self,self.player)
                    elif event.key == K_c:
                        self.player.cast(self)
                    elif event.key == K_p:
                        self.player.deitypower(self)
                    elif event.key == K_DOWN:
                        self.keydown = 2
                        
                        #FIXME keydown = 2
                        #self.room.moveup()    
                    elif event.key == K_LEFT:
                        self.room.moveright()
                        self.room.direction = "left"
                        self.player.direction = "left"#FIXME
                    elif event.key == K_RIGHT:
                        self.room.moveleft()
                        self.room.direction = "right"
                        self.player.direction = "right"
                    elif event.key == K_UP:
			self.prevroomnumber = self.roomnumber 
                        self.roomnumber = self.room.exit(self)
			print "UP key : roomnumber == %d" % (self.roomnumber)
                        self.chooseroom(self.roomnumber,self.font)
                        if self.roomnumber == 0:
                            if self.room.fall(self.player) == 2:
                                self.player.jump(self.room)    
                           
                    elif event.key == K_i:
#                        self.level.gameover = 1
                        flag = 0
                        inventory = Inventory()
		
                        if self.room.inventoryknife1 == 1:
                       		inventory.additem(Inventoryknife1())
			if self.room.inventorymasterkey == 1:
                       		1###FIX for key in inventory.additem(Inventorymasterkey())
                        if self.room.inventorykey1 == 1:
                       		1###FIX for key in inventory.additem(Inventorykey1())
                       	if self.room.inventorykey2 == 1:
                       		1###FIX for key in inventory
                       	if self.room.inventorybow1 == 1:
                                inventory.additem(Inventorybow1())
                       		###FIX for key in inventory
                       	if self.room.inventoryspidereye1 == 1:
                                inventory.additem(InventorySpiderEye())
                       		###FIX for key in inventory
			while flag == 0:#NOTE1
                            sleep(0.01)
                            for event in pygame.event.get():
                                if event.type == QUIT:
                                    return

                                elif event.type == KEYDOWN:
                                    if event.key == K_LEFT:
                                        inventory.moveleft()
                                    elif event.key == K_RIGHT:
                                        inventory.moveright()
                                    elif event.key == K_z or event.key == K_x:
                                        self.room.inventoryitem = inventory.getitem(self.room.inventoryitem)
                                        if self.room.inventoryitem:
                                            self.room.inventoryitem.setintaskbar(self.taskbar)
                                        flag = 1


                                inventory.draw(self.screen)
                                pygame.display.update()



                    elif event.key == K_s: # spellbook
#                        self.level.gameover = 1
                        flag = 0
                        spellbook = SpellBook()
		
			##if Scrollinvisibility(0,0,0,0,"1","1").readkeys(None):
                        ##    spellbook.additem(Inventoryscrollinvisibility())
                       	if self.room.spellbookscrollmagicmissile1 == 1:
                                spellbook.additem(SpellBookScrollMagicMissile1())
			if self.room.spellbookscrollseeinvisibility1 == 1:
                        	spellbook.additem(SpellBookScrollseeinvisibility())
				
			while flag == 0:#NOTE1
                            sleep(0.01)
                            for event in pygame.event.get():
                                if event.type == QUIT:
                                    return

                                elif event.type == KEYDOWN:
                                    if event.key == K_LEFT:
                                        spellbook.moveleft()
                                    elif event.key == K_RIGHT:
                                        spellbook.moveright()
                                    elif event.key == K_z or event.key == K_x:
                                        self.room.spellbookitem = spellbook.getitem(self.room.spellbookitem)
                                        if self.room.spellbookitem:
                                            self.room.spellbookitem.setintaskbar(self.taskbar)
                                        flag = 1


                                spellbook.draw(self.screen)
                                pygame.display.update()


                    elif event.key == K_d: # priest spells 
                        flag = 0
                        priestspells = PriestSpells()
			if self.currentdomain:
				for i in range(1, self.currentdomain.currentpriestlevel):
					priestspells.additem(self.currentdomain.spells[i])
	
                       			### if self.room.priestspellsscrollmagicmissile1 == 1:
                        		###        priestspells.additem(SpellBookScrollMagicMissile1())
                        ### test 
                        ### priestspells.additem(PriestSpellsEnhancePower())
			while flag == 0:
                            sleep(0.01)
                            for event in pygame.event.get():
                                if event.type == QUIT:
                                    return

                                elif event.type == KEYDOWN:
                                    if event.key == K_LEFT:
                                        priestspells.moveleft()
                                    elif event.key == K_RIGHT:
                                        priestspells.moveright()
                                    elif event.key == K_z or event.key == K_x:
                                        self.room.priestspellsitem = priestspells.getitem(self.room.priestspellsitem)
                                        if self.room.priestspellsitem:
                                            self.room.priestspellsitem.setintaskbar(self.taskbar)
                                        flag = 1


                                priestspells.draw(self.screen)
                                pygame.display.update()
 
	    pickupid = self.room.pickup(self.player)
	    if pickupid:
                str = ""
		if pickupid == 5: # NOTE : key1 id
		    self.key1 = 1
		    self.room.inventorykey1 = 1
		    str = "You found a small key."
		    gameflag = 0
		elif pickupid == 6: # NOTE : masterkey id
		    #self.room.inventorymasterkey = 1
		    str = "You healed."
		    gameflag = 0
		    self.player.hitpoints = self.player.maxhitpoints
		elif pickupid == 7:# NOTE : masterkey id
		    self.room.inventorymasterkey1 = 1
		    str = "You found a master key."
		    gameflag = 0
		elif pickupid == 8:
		    self.room.inventorybow1 = 1
		    #self.player.setbow()
		    #taskbar.setbow()
		    str = "You found a bow. See inventory."
		    gameflag = 0
		    #do not set automatically self.taskbar.setbow()
		elif pickupid == 9:
		    self.room.inventoryspidereye1 = 1
		    #self.player.setbow()
		    #taskbar.setbow()
		    str = "You found an eye. See inventory."
		    gameflag = 0
		elif pickupid == 10:
		    str = "Your mana increases."
		    self.player.manapoints = self.player.maxmanapoints
		    gameflag = 0
		elif pickupid == 11:
		    self.room.spellbookscrollmagicmissile1 = 1
		    self.room.spellbookscrollseeinvisibility1 = 1
		    str = "You found a Missile and See Invisible scroll."
		    gameflag = 0
		else:
                    gameflag = 1
                while gameflag == 0:
                    pygame.key.set_repeat(1000,1000)
                    self.screen.blit(blankimage, (0,0))
                    self.taskbar.draw(self)
                    heartmeter.draw(self.screen)
                    manameter.draw(self.screen)
                    self.room.draw(self.screen,self.player,self.taskbar)
                    self.player.update(self.room)
                    self.taskbar.draw(self)
                    self.screen.blit(self.font3.render(str, 8, (255,255,255)), (10,100))
                    
                    pygame.display.update()
                    sleep(0.01)
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            return
                        elif event.type == KEYDOWN:
                            if (event.key == K_x or
                                  event.key == K_z):
                                    gameflag = 1                       
                pygame.key.set_repeat(10,100)
#		elif pickupid == 2: ## NOTE: dungeonentrance 2 id opens with key 1
#                    if self.inventorykey1 == 1:
#                        self.room.removeentrance2()
#                elif pickupid == 3: # NOTE dungeon key 1 id
#                    self.inventorykey1 = 1
#                elif pickupid == 4: # NOTE dungeon key 2 id
#                    self.inventorykey2 = 1
#                elif pickupid == 5: # NOTE ruby sword id
#                    self.inventoryrubysword = 1
#                    self.taskbar.setrubysword()
                    
            if self.room.collide(self.player) == 1 or self.player.hitpoints <= 0: # NOTE: return 1 after self.player heartmeter runs out (self.player.hit)
        	endingimage = pygame.image.load('./pics/endingscreen.bmp').convert()
        	while gameover == 0:
	            	pygame.display.update()
        	    	self.screen.blit(endingimage, (0,0))
        	    	sleep(0.01)
            		for event in pygame.event.get():
                		if event.type == QUIT:
                    			return
                		elif event.type == KEYDOWN:
                    			gameover = 1
					return
                		if event.type == pygame.MOUSEBUTTONDOWN:
                    			gameover = 1
					return
				    
            #if self.room.collide(self.player) == 3 or self.room.collide(self.player) == 2:###Dungeon wall
	    
            #elif self.room.relativey > prevy:
            #    self.room.relativey -= abs(prevy-self.room.relativey)
                #self.room.undomoveX()
            if self.room.collidewithropes(self.player) == 2:
                
                while gameflag == 0:
                    sleep(0.01)
                    for event in pygame.event.get():
                        if event.type == QUIT:
                            return
                        elif event.type == KEYDOWN:
            	    
                            # self.player 1 key controls
                            ##self.player.draw(self.screen)
                            ##if event.key == K_z:
                             ##   self.player.fight(self.room)  
                            if event.key == K_UP:
                                if self.room.collidewithropes(self.player) == 2:
                                    self.room.movedown()   
                            elif event.key == K_DOWN:
##                              if at the end of the rope, have to jump off  
                                if self.room.collidewithropes(self.player) == 2:
                                    self.room.moveup()
                            elif event.key == K_RIGHT:
                                self.room.moveleft()
                                gameflag = 1    
                            elif event.key == K_LEFT:
                                self.room.moveright()
                                gameflag = 1
                            if event.key == K_z:
                                self.player.fight(self.room,self,self.player)
                            elif event.key == K_x:
                                gameflag = 1
                            
                    sleep(0.05)
                    self.room.draw(self.screen,self.player,self.taskbar)
                    self.player.update(self.room)
                    self.player.drawclimbing(self.screen)
                    self.taskbar.draw(self)
                    heartmeter.draw(self.screen) 
                    manameter.draw(self.screen) 
                    pygame.display.update()
                    self.screen.blit(blankimage, (0,0))

            # update self.player (jump) before fall
            #if ((not (self.room.collideX(self.player) and self.room.collideY(self.player)))
            #    or
            if self.room.collideXY(self.player) == 5:
            	self.room.undomoveX()
        	self.room.undomoveX()
        	#self.room.undomoveX()
        	   
	    print "relx=%d rely=%d" % (self.room.relativex, self.room.relativey) 
            self.room.draw(self.screen,self.player,self.taskbar)
            self.player.update(self.room)
            f = self.room.fall(self.player)
            if f == 2:                
                #self.room.undomove()
                gameflag = 0
            elif f == 0:
             	### print "room depths=%d h=%d" % (self.room.relativey,self.room.h)   
                if self.room.relativey < self.room.h:
                    endingimage = pygame.image.load('./pics/endingscreen.bmp').convert()
                    while gameover == 0:
                            pygame.display.update()
                            self.screen.blit(endingimage, (0,0))
                            sleep(0.01)
                            for event in pygame.event.get():
                                    if event.type == QUIT:
                                            return
                                    elif event.type == KEYDOWN:
                                            gameover = 1
                                            return
                                    if event.type == pygame.MOUSEBUTTONDOWN:
                                            gameover = 1
                                            return
                                        #gameflag = 1
##
            
            #if self.room.relativey < prevy:
            #    self.room.relativey = prevy#abs(prevy-self.room.relativey)

            ### print 'room-self.player x=%d y=%d' % (self.room.relativex,self.room.relativey)
            
            if self.keydown == 1:
                self.keydown = 0
                self.player.draw(self.screen)
            elif self.keydown == 2:
                self.keydown = 2
                self.player.drawduck(self.screen)
                self.player.h = 32
            else:
                self.player.drawstatic(self.screen)
            
            #self.player.draw(self.screen)
	    
            # fight for enemies
            # remove dead game objects

	    ### Set self.player hitpoints in life bar
	    heartmeter.index = self.player.hitpoints
	    manameter.index = self.player.manapoints
            for o in self.room.gameobjects:
                if o:
                    o.fight(self.room,self.player)
            for o in self.room.gameobjects:
                if o and o.hitpoints <= 0:
		    ### add to deities watching and alter by killed enemy :
		    self.player.enemykilledon(o)
                    self.room.removeobject(o)

            self.taskbar.draw(self)
            heartmeter.draw(self.screen)
            manameter.draw(self.screen)
            
            if self.talker != None:
                self.talker.drawtalk(self.screen,self.font2)
		talkover = 0
        	while talkover == 0:
            		for event in pygame.event.get():
                		if event.type == QUIT:
                    			return
                		elif event.type == KEYDOWN:
                    			if event.key == K_x or event.key == K_z:

						self.talker = None
						talkover = 1

            pygame.display.update()
            self.screen.blit(blankimage, (0,0))
            
    def setdomain(self, domain):
	self.currentdomain = domain

    def sethitf(self, hitf):
        for i in self.room.gameobjects:
            i.hitf = hitf

    def setxy(self,xx,yy):
        self.x = xx
        self.y = yy

    def setplayerxy(self,xx,yy):
        self.player.x = xx
        self.player.y = yy

    # NOTE: set x y in maproom1 and Game() will set it with game.x (self.x) etc. 
    def chooseroom(self, roomnumber,font):
        if (roomnumber == 0):
            return
        # Moon woods
        elif (roomnumber == 1):
            self.talker = None
            self.room = Maproom1(self.x,self.y)
	# Beneath Nether Mountains
        elif (roomnumber == 2.1):
            self.talker = None
            self.room = Maproom2_1(self.x,self.y)
	    self.room.relativex = self.x
	    self.room.relativey = self.y
	    if self.key1:
		self.room.inventorykey1 = 1
        # Beneath Nether Mountains - sewers with item    
        elif (roomnumber == 2.2):
            self.talker = None
            self.room = Maproom2_2(self.x,self.y)
	# Beneath Nether Mountains - after door with gem
        elif (roomnumber == 2.3 and self.room.inventorykey1 == 1):
            self.talker = None
	    if self.prevroomnumber == 2.1:
            	self.room = Maproom2_3(self.x,self.y,self)
	    elif self.prevroomnumber == 2.4 and self.bossflag1 >= 3:
            	self.room = Maproom2_3(self.x,self.y,self)
		self.room.bossflag1 = 4
            elif self.bossflag1 == -1: # boss is dead
		self.room = Maproom2_3(self.x,self.y,self)
	    else: # init room with spider boss
		self.room = Maproom2_3(self.x,self.y,self)
		self.room.bossflag1 = 0
		
	    self.room.inventorykey1 = 0
        elif (roomnumber == 2.4):
            self.talker = None
            self.room = Maproom2_4(0,-180,self)
	    self.room.inventorykey1 = 1
        elif (roomnumber == 5):
            self.talker = None
            self.room = Maproom5(self.x,self.y)
        elif (roomnumber == 6):
            self.talker = None
            self.room = Maproom6(self.x,self.y)
        elif (roomnumber == 7):
            self.talker = None
            self.room = Maproom7(self.x,self.y)
        elif (roomnumber == 8):
            self.talker = None
            self.room = Maproom8(self.x,self.y)
        elif (roomnumber == 9):
            self.talker = None
            self.room = Maproom9(self.x,self.y)
        elif (roomnumber == 10):
            self.talker = None
            self.room = Maproom10(self.x,self.y)
        elif (roomnumber == 11):
            self.talker = None
            self.room = Maproom11(self.x,self.y)
        elif (roomnumber == 12):
            self.talker = None
            self.room = Maproom12(self.x,self.y)
        elif (roomnumber == 13):
            self.talker = None
            self.room = Maproom13(self.x,self.y)
        elif (roomnumber == 14):
            self.talker = None
            self.room = Maproom14(self.x,self.y)
        # set sword parameters
        #if self.room.inventoryrubysword:
        #    self.sethitf(self.room.gameobjects.hit2)
            
if __name__ == "__main__":
    foo = Game()



