
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from rng import *
from strength import *
from dexterity import *
from intelligence import *
from constitution import *
from wisdom import *
from charisma import *
from armorclass import *
from agility import *
from vitality import *
from luck import *
from weaponuse import *
from parry import *
from dodge import *
from stealth import *
from picklocks import *
from throwing import *
from climbing import *
from communicate import *
from honor import *
from stamina import *
from mana import *
from magic import *
from health import *

class Gameobject:
    "Game object"
    def __init__(self, xx,yy):
	self.x = xx 
        self.y = yy
	# default width and height 
        self.w = 48
        self.h = 48
        self.SCREENH = 640
        self.SCREENW = 480
        ## dungeon statue as default picture
        ## self.image = pygame.image.load('./pics/dungeon-statue1-36x36.bmp').convert()
        self.image = pygame.image.load('./pics/nopicture.bmp').convert()
        self.image.set_colorkey((0,0,0)) 
        self.hitpoints = 1
        self.maxhitpoints = 1
        self.manapoints = 1
        self.maxmanapoints = 1
        # NOTE : decrease 1 hitpoint with default sword
        self.hitf = self.hit1
	self.annulinvisible = 0
	self.strength = Strength(10)
	self.dexterity = Dexterity(10)
	self.intelligence = Intelligence(12)
	self.constitution = Constitution(self.maxhitpoints)
	self.wisdom = Wisdom(12)
	self.charisma = Charisma(12)
	self.armorclass = ArmorClass(10)

	self.agility = Agility(120)
	self.vitality = Vitality(120)
	self.luck = Luck(120)
	self.weaponuse = WeaponUse(120)
	self.parry = Parry(100)
	self.dodge = Dodge(100)
	self.stealth = Stealth(110)
	self.picklocks = PickLocks(70)
	self.throwing = Throwing(100)
	self.climbing = Climbing(90)
	self.communicate = Communicate(110)
	self.honor = Honor(100)
	self.stamina = Stamina(self.maxhitpoints)
	self.mana = Mana(self.maxmanapoints)
	self.health = Health(self.maxhitpoints)
	self.type = 0
	self.rng = RNG(self)
      
    def alterlikedbygod(self, n):
	self.type += n
 
    def getrng(self):
	return self.rng
 
    def draw(self, screen, room):
        screen.blit(self.image,(self.x+room.relativex,self.y+room.relativey))
	    
	     
    def collidewithsword(self, room, player):
        #print 'gameobject x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if (player.x-room.relativex > self.x and#-self.w  and 
	player.x-room.relativex < self.x+self.w and 
	player.y-room.relativey > self.y and#-self.h and 
	player.y-room.relativey < self.y + self.h):
	    #print "collision with Game Object!"
	    return 1 
	else:
	    return 0

    def collide(self, room, player):
        if (player.x-room.relativex >= self.x  and 
	player.x-room.relativex <= self.x+self.w and 
	player.y+player.h-room.relativey >= self.y+self.h and #FIXED +self.h
	player.y-room.relativey <= self.y):
	    #print "collision in box!"	
	    return 4 #FIXME1 check for previous return 2
	else:
	    return 0

    def collidetalk(self, room, player):
	return 0

    def collideXX(self, room, player):
        if (player.x-room.relativex >= self.x  and 
	player.x-room.relativex <= self.x+self.w and
            player.y-room.relativey+player.h > self.y):
	    #print "+++++++++++++++++++++++++++++collision in box!"	
	    return 5 #FIXME1 check for previous return 2
	else:
	    return 0

    def collideX(self, room, player):
        if (player.x-room.relativex >= self.x  and 
	player.x-room.relativex <= self.x+self.w):# and
#            player.y-room.relativey < self.y):
	    #print "+++++++++++++++++++++++++++++collision in box!"	
	    return 5 #FIXME1 check for previous return 2
	else:
	    return 0

    def collideY(self, room, player):
        if (player.y-room.relativey >= self.y  and 
	player.y-room.relativey <= self.y+self.w):
	    #print "****************************collision in box!"	
	    return 5 #FIXME1 check for previous return 2
	else:
	    return 0

    def collideXY(self, room, player):
        if (player.y-room.relativey >= self.y  and 
	player.y-room.relativey <= self.y+self.h and
        player.x-room.relativex >= self.x  and 
	player.x-room.relativex <= self.x+self.w):
	    #print "****************************collision in box!"	
	    return 5 #FIXME1 check for previous return 2
	else:
	    return 0

    def collidebow(self, room, player):
        if (player.x-room.relativex >= self.x-350  and 
	player.x-room.relativex <= self.x+self.w+350 and 
	player.y+player.h-room.relativey >= self.y and #FIXED +self.h
	player.y-room.relativey <= self.y):
	    print "collision in bow!"	
	    return 4 #FIXME1 check for previous return 2
	else:
	    return 0
	
    def collideknife(self, room, player):
        if (player.x-room.relativex >= self.x-300  and 
	player.x-room.relativex <= self.x+self.w+300 and 
	player.y+player.h-room.relativey >= self.y and #FIXED +self.h
	player.y-room.relativey <= self.y):
	    print "collision in knife!"	
	    return 4 #FIXME1 check for previous return 2
	else:
	    return 0
	
    def fallcollide(self, room, player):
        # FIX BUG
        if (player.y-room.relativey+player.h >= self.y +self.h and 
            player.y-room.relativey <= self.y + self.h and
            player.x-room.relativex >= self.x and 
            player.x-room.relativex <= self.x+self.w):
	    #print "FALL collision with Game Object!"
	    return 1 
        else:
	    return 0 ## for game self.talker



    def collidepickup(self, room,player):
##        #print 'keyx=%d keyy=%d playerx=%d playery=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
##	if (player.x-room.relativex > self.x  and 
##	player.x-room.relativex < self.x+self.w and 
##	player.y-room.relativey > self.y and 
##	player.y-room.relativey < self.y+self.h):
##	    print "------------------pickup collision!"	
##	    return 3 
##	else:
	    return 0  
    
    def collideobjectX(self, room):
	for i in room.gameobjects:
	    if i != None:	
	        if (self.x > i.x  and 
		    self.x < i.x+i.w):
	            return 1 
	return 0

    def collideobjectY(self, room):
	for i in room.gameobjects:
	    if i != None:	
	        if (self.y > i.y  and 
		    self.y < i.y+i.h):
	            return 1 
	return 0
 
    def collideobjectXY(self, room,player):
	for i in room.gameobjects:
	    if i:		
	        if (self.x > i.x  and 
	 	    self.x < i.x+i.w and 
	            self.y > i.y and 
	            self.y < i.y+i.h):
	            return 1 
	return 0 
    
    def update(self,room,player):
	1

    def pickup(self, player):
        return 0

    def hit1(self):## NOTE decreases hitpoints
        self.hitpoints -= 1
        return self.hitpoints

    def hit2(self):## NOTE decreases hitpoints
        self.hitpoints -= 2
        return self.hitpoints

    def hitwithweapon(self,damage):
	if damage > 0:
            print 'enemy is hit!'
            self.hitpoints -= damage

    def fight(self,room,player):
	1
    
    def undomove(self):
	1

    # FIXME2
    def collidewithenemy(self,room,enemy):
        return None


##    def collideboxes(self, room, entityorbox):
##        if (entityorbox.x + entityorbox.w >= self.x and entityorbox.x <= self.x):# and
##    #        entityorbox.y >= self.y):
##	    print "collision with Gameobject and box!"
##	    return 1 
##	else:
##	    return 0

    def collideboxes(self, room, entityorbox):
        # NOTE: that no relx rely from  map are needed
        #print 'gameobject x=%d y=%d entityorbox x=%d y=%d' % (self.x,self.y,entityorbox.x-room.relativex,entityorbox.y-room.relativey)
##	if (entityorbox.x > self.x  and 
##	entityorbox.x < self.x+self.w and
        
##	if (entityorbox.x + entityorbox.w >= self.x and entityorbox.x <= self.x and
##            entityorbox.y + entityorbox.h >= self.y and entityorbox.y <= self.y):# and
##    #        entityorbox.y >= self.y):
##	    print "collision with gameobject and box!"
##	    return 1 
##	else:
	return 0 ## for game self.talker

    def talk(self, game):
	return None 

    def drawtalk(self,screen,font):
	1

    def godattention(self, player, idx):
	player.godattention(self, idx)

    def dream(self, player):
	self.strength.set(self.strength.get() - (self.rng.rolld4() + 1))
	player.dream(self)
