
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from deepgnome1 import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from ghostwandering import *
from ghostwanderingplatform import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from demon import *
from demonpriest import *
from beholder import *
from demonpigflying import *
from tilebox import *
from healingpotion import *
from manapotion import *
from scrollmagicmissile1 import *
from rope import *
from roof import *
from bow1 import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from spider1 import *
from scorpionred1 import *
from scorpionredplatform1 import *
from scorpionred2 import *
from skeleton1 import *
from fishman1 import *

from roadsign import *

class Maproom2_4(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y, game):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg2.4-3200x600.bmp").convert()
        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
	### self.gameobjects.append(DeepGnome1(800,480))

        #self.gameobjects.append(Skeleton1(700,315))
        #self.gameobjects.append(Skeleton1(2000,315))
        self.h = -600
        # FIXME1 do not collide with other enemies for boxes
	#self.gameobjects.append(Fishman1(300,400-72))
	#self.gameobjects.append(Fishman1(400,400-72))
	#self.gameobjects.append(Fishman1(500,400-72))

	self.gameobjects.append(Spider1(400,500))
	self.gameobjects.append(Spider1(700,500))
	self.gameobjects.append(Spider1(800,500))

	self.gameobjects.append(GhostWanderingPlatform(300,45,100,500))
	self.gameobjects.append(Beholder(1450,0,game))
	self.gameobjects.append(DemonPriest(1450,400,game))
	### self.gameobjects.append(ScorpionRedPlatform1(330,50,330,480))
	self.gameobjects.append(ScrollMagicMissile1(330,50))

        # left NOTE!!! : boxes collide so put them after enemies !
        self.gameobjects.append(Box(0,550,3200,12))
        ### self.roofs.append(Roof(0,0,3200,12))

	# platforms
        self.gameobjects.append(Box(450,400,130,12))
        self.roofs.append(Roof(450,400,130,12))
        self.gameobjects.append(Box(500,400,12,200))

        self.gameobjects.append(Box(100,280,480,12))
        self.roofs.append(Roof(100,280,480,12))

	self.ropes.append(Rope(580, 180, 200))

        self.gameobjects.append(Box(325,100,165,12))
        self.roofs.append(Roof(325,100,165,12))

	self.ropes.append(Rope(485, 50, 210))



	
        # left wall
        self.gameobjects.append(Box(0,0,12,480))
        # right wall
        self.gameobjects.append(Box(960,0,12,480))

        # ropes       
        #self.ropes.append(Rope(980,455,140))
        # floor under rope
                
        self.locationtext = "Luruar - Beneath Nether Mountains"

	# needs to be set for exiting this room towards room 2.3 
	self.spellbookscrollmagicmissile1 = 0


    def draw(self,screen,player,taskbar):
        sleep(0.05) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
	j = 0
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
		if self.godmode:
			i.godattention(player,j)
	    j += 1
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
    def setxyfromdoorleft(self,game):
        game.x = -620
	game.y = -950

    def isroomdoorexitleft(self,game):
        print "exit relx=%s rely=%s" % (self.relativex,self.relativey)
	if self.relativex > -20 and self.relativex < 30 and self.relativey >= -190:
		return 1
	return 0

    def exit(self, game):
	print "*** calling exit from room 2.4"
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 2.3
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
          return None
