
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from rng import *
from intelligence import *
from magicmissileenemy1 import *
from shockinggraspenemy1 import *
from vampirictouchenemy1 import *
from spelldictionaryenemy import *
import math

class NecromancerSpellDictionaryEnemy(SpellDictionaryEnemy):
    ""
    def __init__(self, game, enemy):
	SpellDictionaryEnemy.__init__(self, game, enemy)
	self.dict["Magic Missile 1"] = self.magicmissile1 
	self.dict["Shocking Grasp"] = self.shockinggrasp 
	self.dict["Vampiric Touch"] = self.vampirictouch

    def magicmissile1(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(MagicMissileEnemy1(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.set(self.enemy.magic.get() - 1)

    def shockinggrasp(self):
	if self.enemy.magic.get() <= 0:
		return

	# only grasp within range
	if abs(self.game.player.x - self.enemy.x) < 50:
		self.game.room.gameobjects.append(ShockingGraspEnemy1(self.enemy.x,self.enemy.y,self.game.player.x,self.game.player.y,self.game.player))
		self.enemy.magic.set(self.enemy.magic.get() - 4)

    def vampirictouch(self):
	if self.enemy.magic.get() <= 0:
		return

	# only touch within range
	if abs(self.game.player.x - self.enemy.x) < 50:
		self.game.room.gameobjects.append(VampiricTouchEnemy1(self.enemy.x,self.enemy.y,self.game.player.x,self.game.player.y,self.game.player))
		self.enemy.magic.set(self.enemy.magic.get() - 4)



	

	
