
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class Roof(Gameobject):
    "Roof"
    def __init__(self, xx,yy,ww,hh):
        Gameobject.__init__(self,xx,yy)
        self.w = ww
        self.h = hh
        self.hitpoints = 100000000 #FIX else wall/floor disappears
        #FIX is in base class self.image = pygame.image.load('./pics/.bmp').convert()
        #self.image.set_colorkey((0,0,0)) 

    def setimage(self, imagefilename,r,g,b):
        self.image = pygame.image.load(imagefilename).convert()
        self.image.set_colorkey((r,g,b)) 

    def collide(self, room, player):
	if (player.x-room.relativex >= self.x  and 
	player.x-room.relativex <= self.x+self.w and 
	player.y+player.h-room.relativey >= self.y+self.h and #FIXED +self.h
	player.y-room.relativey <= self.y):
	    #print "collision in box!"	
	    return 4 #FIXME1 check for previous return 2
	else:
	    return 0


##    def fallcollide(self, room, player):
##        # FIX BUG
##        print 'box x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
##	if (player.y-room.relativey+player.h+1 > self.y and 
##            player.y-room.relativey+player.h+1 < self.y+self.h):
##	    print "collision with Game Object box!"
##	    return 1 
##	else:
##	    return 0 ## for game self.talker

    def collideboxes(self, room, entityorbox):
       if (entityorbox.x > self.x  and 
	entityorbox.x < self.x+self.w and 
	entityorbox.y+entityorbox.h > self.y and #FIXED +self.h
	entityorbox.y < self.y):
	    #print "collision in box!"	
	    return 2 #FIXME1 check for previous return 2
       else:
	    return 0
