
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class RaceSelector:
    "Race Selector"
    def __init__(self, screen, font):
        self.screen = screen
        self.font = font
        self.background = pygame.image.load('./pics/blank.bmp').convert()
        self.race = "Human"
        self.humanimage = pygame.image.load('./pics/taskbar-PC.bmp').convert()
        self.gnollimage = pygame.image.load('./pics/taskbar-PC-gnoll.bmp').convert()
        self.kattaimage = pygame.image.load('./pics/taskbar-PC-kattafighter.bmp').convert()
        self.elfimage = pygame.image.load('./pics/taskbar-PC-elffighter.bmp').convert()
	self.picture = self.elfimage 
         
    def draw(self):
        ### self.screen.blit(self.background, (0, 300))       
        self.screen.blit(self.humanimage, (0,0))
	self.screen.blit(self.font.render("Human", 8, (255,255,255)), (10,50))
        self.screen.blit(self.gnollimage, (50,0))
	self.screen.blit(self.font.render("Gnoll", 8, (255,255,255)), (50,70))
        self.screen.blit(self.kattaimage, (100,0))
	self.screen.blit(self.font.render("Katta", 8, (255,255,255)), (100,50))
        self.screen.blit(self.elfimage, (150,0))
	self.screen.blit(self.font.render("Elf", 8, (255,255,255)), (150,70))
	self.screen.blit(self.font.render("Choose race", 8, (255,255,255)), (10,90))
        

    def select(self):
        while 1:
                self.draw()
                pygame.display.update()
                for event in pygame.event.get():
                    if event.type == QUIT:
                        return
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        position = pygame.mouse.get_pos()
                        mousex = position[0]
                        mousey = position[1]
                        
                        if mousex > 0 and mousex < 50 and mousey > 0 and mousey < 50:
                            self.race = "Human"    
			    self.picture = self.humanimage
                            return
                        elif mousex > 50 and mousex < 100 and mousey > 0 and mousey < 50:
                            self.race = "Gnoll"    
			    self.picture = self.gnollimage
                            return
                        elif mousex > 100 and mousex < 150 and mousey > 0 and mousey < 50:
                            self.race = "Katta"    
			    self.picture = self.kattaimage
                            return
                        elif mousex > 150 and mousex < 200 and mousey > 0 and mousey < 50:
                            self.race = "Elf"    
			    self.picture = self.elfimage
                            return
			else:
				self.race = "Elf"
			    	self.picture = self.elfimage
				return
    def askrace(self):
        return self.race

    def askpicture(self):
        return self.picture

