
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class Taskbar:
    "Taskbar"
    def __init__(self, screen, font, player):
        self.screen = screen	
        self.font = font
        self.player = player
        #self.foreground = pygame.image.load('./pics/taskbar01.bmp').convert()
        #self.foreground.set_colorkey((0,0,0)) 
        ###self.pc = pygame.image.load(player.askpicture()).convert()
        self.swordimage = pygame.image.load('./pics/sword1-36x36.bmp').convert()
        self.swordimage.set_colorkey((0,0,255))
	self.priestspellimage = None
	self.priestspellname = "" 
	self.spellimage = None
	self.spellname = "" 
        self.font2 = pygame.font.SysFont("Vera", 25)
        
    def setswordimage(self, imagefilename,r,g,b):
        self.swordimage = pygame.image.load(imagefilename).convert()
        self.swordimage.set_colorkey((r,g,b)) 

    def setspellimage(self, imagefilename,r,g,b):
        self.spellimage = pygame.image.load(imagefilename).convert()
        self.spellimage.set_colorkey((r,g,b)) 
	
    def setpriestspellimage(self, imagefilename,r,g,b):
        self.priestspellimage = pygame.image.load(imagefilename).convert()
        self.priestspellimage.set_colorkey((r,g,b)) 
	
    def draw(self,game):
        self.screen.blit(game.raceselector.askpicture(), (10, 10))
        self.screen.blit(self.font.render(game.player.askclass(), 6, (255,0,0)), (0+10,0+60))
        self.screen.blit(self.font2.render(game.room.locationtext, 6, (255,255,255)), (0+100,0+60))
        self.screen.blit(self.swordimage, (65, 10))
	if self.spellimage:
        	self.screen.blit(self.spellimage, (105, 10))
        	self.screen.blit(self.font.render(self.spellname, 6, (255,255,255)), (90,40))
	if self.priestspellimage:
        	self.screen.blit(self.priestspellimage, (175, 10))
        	self.screen.blit(self.font.render(self.priestspellname, 6, (255,255,255)), (160,40))

    def draw0(self,text):
        ### FIXME self.screen.blit(game.raceselector.askpicture(), (10, 10))
        self.screen.blit(self.font.render(self.player.askclass(), 6, (255,0,0)), (0+10,0+60))
        self.screen.blit(self.swordimage, (65, 10))
	self.drawlocationtext(text)

    def drawlocationtext(self,text):
        self.screen.blit(self.font2.render(text, 6, (255,255,255)), (0+100,0+60))

    def setrubysword(self):
        self.setswordimage('./pics/taskbar-rubysword1-32x32.bmp',0,0,255)

    def setsword1(self):
        self.setswordimage('./pics/sword1-36x36.bmp',0,0,255)

    def setscrollmagicmissile1(self,item):
        self.setspellimage('./pics/scrolls-magicmissile1.bmp',255,255,255)
	self.spellname = item.spellname

    def setscrollmagicmissile2(self,item):
        self.setspellimage('./pics/scrolls-magicmissile2.bmp',255,255,255)
	self.spellname = item.spellname

    def setscrollmagicmissile3(self,item):
        self.setspellimage('./pics/scrolls-magicmissile3.bmp',255,255,255)
	self.spellname = item.spellname

    def setscrollseeinvisibility(self,item):
        self.setspellimage('./pics/scrolls-seeinvisibility.bmp',255,255,255)
	self.spellname = item.spellname

    def setenhancepower(self,item):
        self.setpriestspellimage('./pics/priestspell-enhancepower.bmp',255,255,255)
	self.priestspellname = item.priestspellname

    def setbow(self):
        self.setswordimage('./pics/bow1-36x36.bmp',0,0,0)
        self.swordimage.set_colorkey((0,0,255)) 
